/*
 * StreamHandler.java
 *
 * Created on December 9, 2005, 6:54 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package serialBridge;

import java.io.InputStream;
import java.io.OutputStream;


public class StreamHandler {
    
    private InputStream is;
    private OutputStream os;
    private boolean stop;
    ReadThread readThread;
    WriteThread writeThread;
    byte[] buffer = new byte[1024];
    int writerPosition;
    int readerPosition;
            
    /** Creates a new instance of StreamHandler */
    public StreamHandler(InputStream is, OutputStream os) {
        this.is = is;
        this.os = os;
    }
    
    private class ReadThread extends Thread {
        ReadThread() {
            super("StreamHandler.ReadThread");
        }
        
        public void run() {
            while (!stop) {
//                if (writerPosition >)
//                position += is.read()
            }
        }
    }
    
    private class WriteThread extends Thread {
        WriteThread() {
            super("StreamHandler.WriteThread");
        }
        
        public void run() {
            while (!stop) {
                
            }
        }        
    }
    
    public void start() {
        readThread = new ReadThread();
        writeThread = new WriteThread();
        readThread.start();
        writeThread.start();
    }
    
    public void stop() {
        stop = true;
        if (readThread != null) {
            readThread.interrupt();
        }
        if (writeThread != null) {
            writeThread.interrupt();
        }
    }

    /**
     * Holds value of property partner.
     */
    private StreamHandler partner;

    /**
     * Getter for property partner.
     * @return Value of property partner.
     */
    public StreamHandler getPartner() {

        return this.partner;
    }

    /**
     * Setter for property partner.
     * @param partner New value of property partner.
     */
    public void setPartner(StreamHandler partner) {

        this.partner = partner;
    }

    /**
     * Holds value of property sendTrigger.
     */
    private String sendTrigger;

    /**
     * Getter for property sendTrigger.
     * @return Value of property sendTrigger.
     */
    public String getSendTrigger() {

        return this.sendTrigger;
    }

    /**
     * Setter for property sendTrigger.
     * @param sendTrigger New value of property sendTrigger.
     */
    public void setSendTrigger(String sendTrigger) {

        this.sendTrigger = sendTrigger;
    }

    /**
     * Holds value of property maxBytesBuffered.
     */
    private int maxBytesBuffered;

    /**
     * Getter for property maxBytesBuffered.
     * @return Value of property maxBytesBuffered.
     */
    public int getMaxBytesBuffered() {

        return this.maxBytesBuffered;
    }

    /**
     * Setter for property maxBytesBuffered.
     * @param maxBytesBuffered New value of property maxBytesBuffered.
     */
    public void setMaxBytesBuffered(int maxBytesBuffered) {

        this.maxBytesBuffered = maxBytesBuffered;
    }

    /**
     * Holds value of property maxLatency.
     */
    private int maxLatency;

    /**
     * Getter for property maxLatency.
     * @return Value of property maxLatency.
     */
    public int getMaxLatency() {

        return this.maxLatency;
    }

    /**
     * Setter for property maxLatency.
     * @param maxLatency New value of property maxLatency.
     */
    public void setMaxLatency(int maxLatency) {

        this.maxLatency = maxLatency;
    }
}
