/*
 * StringSplit.java
 *
 * Created on January 3, 2006, 2:08 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package util;

public class StringSplit {
    
    public static String[] split(String s, String delims) {
        int count = 0;
        boolean overField = false;
        boolean isDelimiter = false;
        int[] fieldStarts = new int[s.length()/2 + 1];
        int[] fieldStops = new int[s.length()/2 + 1];
        char[] chars = new char[s.length()];
        char[] delimChars = new char[delims.length()];
        

        s.getChars(0, s.length(), chars, 0);
        delims.getChars(0, delims.length(), delimChars, 0);
        
        for (int i=0; i < chars.length; i++) {
            isDelimiter = false;
            for (int j=0; j < delimChars.length; j++) {
                if (chars[i] == delimChars[j]) {
                    isDelimiter = true;
                    break;
                }
            }
            if (!isDelimiter && !overField) {
                fieldStarts[count] = i;
                overField = true;
            } else if (isDelimiter && overField) {
                fieldStops[count++] = i;
                overField = false;
            } else if ((chars.length-1 == count) && overField) {
                //Last field may not have closing delimeter
                fieldStops[count++] = i;
            }
        }
        
        String[] result = new String[count];
        
        for (int i=0; i < count; i++) {
            result[i] = s.substring(fieldStarts[i], fieldStops[i]);
        }
        return result;
    }
    
    public static void main(String[] args) {
        String[] result = StringSplit.split("\tThis  is\ta string. ", " \t");
    }
}
